﻿// For an introduction to the Blank template, see the following documentation:
// http://go.microsoft.com/fwlink/?LinkId=232509
(function () {
    "use strict";

    WinJS.Binding.optimizeBindingReferences = true;

    var app = WinJS.Application;
    var activation = Windows.ApplicationModel.Activation;

    var calc = WinRTComponent;

    var c = new calc.Component();

    app.onactivated = function (args) {
        if (args.detail.kind === activation.ActivationKind.launch) {
            if (args.detail.previousExecutionState !== activation.ApplicationExecutionState.terminated) {
                // TODO: This application has been newly launched. Initialize
                // your application here.
            } else {
                // TODO: This application has been reactivated from suspension.
                // Restore application state here.
            }
            args.setPromise(WinJS.UI.processAll());
        }

		// simple types
		var x = c.add(1, 2);
		var y = c.sub(2, 1);

		// WinRT types
		c.navigate(new Windows.Foundation.Uri("http://channel9.msdn.com/coding4fun/"));
		var date = c.getTime();

		// collections
		var numbers = [1,2,3,4,5,6];
		var average = c.average(numbers);

		var ps = new Windows.Foundation.Collections.PropertySet();
		ps['hi'] = 1234;

		// this will throw an exception as setDictionary expects IMap<string, int>
		// but PropertySet only implements IMap<string, object>
		//c.setDictionary(ps);

		// ths succeeds because it is of type PropertySet
		c.setIPropertySet(ps);

		// if you need concrete types, return the collection from the component and modify it
		var map = c.getMap();
		map['hi'] = 1234;
		c.setDictionary(map);

		// arrays
		average = c.averageArray(numbers);
		numbers = c.arrayCloneReturn(numbers, 10);

		// these won't work!
		//c.arrayReadOnly(numbers, 10);
		//c.arrayWriteOnly(numbers, 10);
		//c.arrayOut(numbers, 10);
		//c.arrayClone(numbers, 10);

		// overload
		c.overload("string");

		// events
		c.onmyevent = function (ev) { console.log("event --> " + ev.field); };
		c.raiseEvent();

		// exceptions
	    try {
			c.throwFileNotFoundException();
		} catch(e) {
			console.log(e.number + " --> " + e.message);
	    } 

	    try {
			c.throwNullReferenceException();
		} catch(e) {
			console.log(e.number + " --> " + e.message);
	    } 

	    try {
			c.throwCOMException();
		} catch(e) {
			console.log(e.number + " --> " + e.message);
	    } 

	    try {
			c.throwMyException();
		} catch(e) {
			console.log(e.number + " --> " + e.message);
	    } 

		// async
		c.asyncAction()
			.then(function() { console.log("done"); })
			.then(function() { return c.asyncOperation(); })
			.then(function(done) { console.log(done); })
			.then(function() { return c.asyncActionCancellation(); })
			.then(function() { console.log("done"); })
			.then(function() { return c.asyncOperationCancellation(); })
			.then(function(done) { console.log(done); })
			.then(function() { return c.asyncActionProgress(); })
			.then(function() { console.log("done"); })
			.then(function() { return c.asyncOperationProgress(); })
			.then(function(done) { console.log(done); });
    };

    app.oncheckpoint = function (args) {
        // TODO: This application is about to be suspended. Save any state
        // that needs to persist across suspensions here. You might use the
        // WinJS.Application.sessionState object, which is automatically
        // saved and restored across suspension. If you need to complete an
        // asynchronous operation before your application is suspended, call
        // args.setPromise().
    };

    app.start();
})();
